Program Klimamessung;
Uses Crt;
const  BA = $3F8;            { COM 1 }

procedure Zeitgeber;
begin
  Port[$43] := $24;          { Timer 0, Mode 2, Lesen: Highbyte }
  Port[$40] := lo (59659);   { Teilerfaktor }
  Port[$40] := hi (59659);   { = 1193180 / 20 }
end;

procedure Uhr;
begin
  Port[$43] := $36;          { Timer 0, Mode 3 }
  Port[$40] := 0;            { Teilerfaktor }
  Port[$40] := 0;            { = 65536 }
end;

function Frequenz (Kanal: Byte): Integer;
var Dummy, Timer, Timer_alt : Integer;
    Eingang, Eingang_alt, Zeit : Byte;
    Portwert : Byte;
    Zaehler : Integer;
begin
 Portwert := 16;                      { CTS }
 if Kanal=2 then Portwert := 32;      { DSR }
 if Kanal=3 then Portwert := 64;      { RI }
 if Kanal=4 then Portwert := 128;     { DCD }
 Zaehler := 0;
 Zeit := 0;
 Inline ($FA);                        { Interrupt sperren }
 Timer := Port[$40] and 128;          { hchstwertiges Bit }
 repeat;
   Timer_alt := Timer;
   Timer := Port[$40] and 128;
 until Timer > Timer_alt;             { 1. Timer-berlauf }
 Eingang_alt := Port[BA+6] AND Portwert;
 repeat
     Timer_alt := Timer;
     Eingang := Port[BA+6] AND Portwert;   { Flanken zhlen }
     if Eingang > Eingang_alt then Zaehler := Zaehler + 1;
     Eingang_alt := Eingang;
     Timer := Port[$40] and 128;      { berlufe zhlen }
     If Timer > Timer_alt then Zeit := Zeit +1;
 until Zeit = 20;                     { 1 Sekunde }
 Inline ($FB);                        { Interrupt freigeben }
 Frequenz := Zaehler;
end;

function Feuchte: Real;
var Messfrequenz: Integer;
begin
  Messfrequenz := Frequenz(1);
  if Messfrequenz > 4520 then
     Feuchte := 100 - 20 * (Messfrequenz-4520) / (4897-4520);
  if Messfrequenz > 4897 then
     Feuchte := 80 - 20 * (Messfrequenz-4897) / (5262-4897);
  if Messfrequenz > 5262 then
     Feuchte := 60 - 20 * (Messfrequenz-5262) / (5509-5262);
  if Messfrequenz > 5509 then
     Feuchte := 40 - 20 * (Messfrequenz-5509) / (5828-5509);
  if Messfrequenz > 5828 then
     Feuchte := 20 - 20 * (Messfrequenz-5828) / (6027-5828);
end;

function Temperatur: Real;
var Messfrequenz : Integer;
begin
  Messfrequenz := Frequenz(2);
  Temperatur := 10 * (Messfrequenz-2065) / (2230-2065);
  if Messfrequenz > 2230 then
     Temperatur := 10 + 10 * (Messfrequenz-2230) / (2475-2230);
  if Messfrequenz > 2475 then
     Temperatur := 20 + 10 * (Messfrequenz-2475) / (2835-2475);
  if Messfrequenz > 2835 then
     Temperatur := 30 + 10 * (Messfrequenz-2835) / (3430-2835);
end;

begin
  ClrScr;
  Zeitgeber;
  repeat
    GotoXY (10,10);
    writeln ('Temperatur =   ',Temperatur:4:2,' C');
    GotoXY (10,12);
    writeln ('rel. Feuchte = ', Feuchte:3:1,' %');
  until KeyPressed;
  Uhr;
end.
