Program MaschinenSteuerung;
uses CRT;
const BA = $378;             { LPT1 }
      rechts = true;
      links = false;
var Schritt1, Schritt2, Schritt3 : Byte;

procedure Init;
begin
  Schritt1 := 1;
  Schritt2 := 1;
  Schritt3 := 1;
  Port[BA] := 17;           { D0=1, D4=1 }
  Port[BA+2] := 1 XOR 11;   { Strobe = 1 }
end;

procedure Motor1 (rechts : Boolean);
begin
  if rechts then begin
    Schritt1 := Schritt1 * 2;
    if Schritt1 = 16 then Schritt1 := 1
  end else begin
    Schritt1 := Schritt1 div 2;
    if Schritt1 = 0 then Schritt1 := 8;
  end;
  Port[BA] := Schritt1 + 16 * Schritt2;
end;

procedure Motor2 (rechts : Boolean);
begin
  if rechts then begin
    Schritt2 := Schritt2 * 2;
    if Schritt2 = 16 then Schritt2 := 1
  end else begin
    Schritt2 := Schritt2 div 2;
    if Schritt2 = 0 then Schritt2 := 8;
  end;
  Port[BA] := Schritt1 + 16 * Schritt2;
end;

procedure Motor3 (rechts : Boolean);
begin
  if rechts then begin
    Schritt3 := Schritt3 * 2;
    if Schritt3 = 16 then Schritt3 := 1
  end else begin
    Schritt3 := Schritt3 div 2;
    if Schritt3 = 0 then Schritt3 := 8;
  end;
  Port[BA+2] := Schritt3 XOR 11;
end;

function Schalter1: Boolean;
begin
  if (Port[BA+1] and 8) = 0 then Schalter1 := true
  else Schalter1 := false;
end;

function Schalter2: Boolean;
begin
  if (Port[BA+1] and 16) = 0 then Schalter2 := true
  else Schalter2 := false;
end;

function Schalter3: Boolean;
begin
  if (Port[BA+1] and 32) = 0 then Schalter3 := true
  else Schalter3 := false;
end;

procedure NullPosition;
begin
  repeat
    Motor1(links);
    delay (5);
  until Schalter1;
  repeat
    Motor2(links);
    delay (5);
  until Schalter2;
  repeat
    Motor3(links);
    delay (5);
  until Schalter3;
end;


procedure Bewegung1;
var N : Word;
begin
  for n:= 1 to 100 do begin   { 100 Schritte }
    Motor1 (rechts);
    Motor2 (rechts);          { alle Motoren }
    Motor3 (rechts);
    delay (5);                { schnell }
  end;
  for n:= 1 to 100 do begin   { 100 Schritte }
    Motor1 (rechts);          { nur Motor 1 }
    delay (10);               { langsam }
  end;
  delay(1000);                { Stillstand 1s }
  for n:= 1 to 100 do begin   { 100 Schritte }
    Motor1 (links);
    Motor2 (links);           { alle Motoren }
    Motor3 (links);
    delay(5);                 { schnell }
  end;
  for n:= 1 to 100 do begin   { 100 Schritte }
    Motor1 (links);           { nur Motor 1 }
    delay (10);               { langsam }
  end;
  delay (1000);               { Stillstand 1s }
end;


begin
  Init;
  NullPosition;
  repeat
    Bewegung1;
  until KeyPressed;
end.
