Program Recorder;
uses CRT;
Const BA = $3F8;             { COM1 }
Type Speicher = Record
   Puffer :Array [1..60000] of Byte;
end;

var Probe: Speicher;
    Ch    : Char;

procedure Oeffnen115200;
begin
  Port [BA+3]:=128;          { Baudeingabe aktivieren }
  Port [BA  ]:= 1;           { Baudrate - LSB, 115200 Baud }
  Port [BA+1]:=  0;          { Baudrate - MSB }
  Port [BA+3]:=  3;          { 8 Bits, No Parity, 1 Stop }
  Port [BA+4]:=  0;          { DTR = 0, CTS = 0 }
end;

procedure Senden  ( Wert : Byte );
   begin
     repeat
     until Port [BA+5] and 32 = 32;      { Abfrage, ob Sendepuffer leer }
     Port [BA]:= (Wert);                 { Byte an Sendepuffer ausgeben }
   end;

function AD : Byte;
var m, n, Stelle : Integer;
    Wert : Byte;
begin
  for m:=1 to 5 do;                    { Verzgerung }
  Port [BA+4] := 0;                    { /CS aus }
  Wert := 0;
  Stelle := 128;
  for n:= 1 to 8 do begin
    if (Port[BA+6] AND 32) = 32 then   { Daten an DSR }
       Wert := Wert + Stelle;
    Port [Ba+4] := 1;                  { Clock an }
    Stelle := Stelle div 2;
    Port [BA+4] := 0;                  { Clock aus }
  end;
  Port [BA+4] := 2;                    { /CS an }
  AD := Wert;
end;

procedure Aufnahme;
var n : word;
    i : integer;
    Ausgabe, Eingabe: Byte;
    SendeByte, Bitwert : Byte;
begin
  with Probe do begin;
    Inline ($FA);
    for n:= 1 to 60000 do Puffer[n] := AD;
    Inline ($FB);
    Ausgabe:= 0;
    for n:= 1 to 60000 do begin
      Ausgabe := Ausgabe + 2;       {Startbit high}
      Bitwert := 1;
      SendeByte := 0;
      Eingabe := Puffer[n];
      for i := 1 to 8 do begin
        if Eingabe < Ausgabe then begin
          SendeByte := SendeByte + Bitwert;
          Ausgabe := Ausgabe - 2;
        end else Ausgabe := Ausgabe + 2;
        BitWert := BitWert * 2;
      end;
    Ausgabe := Ausgabe - 2;       {Stopbit low}
    Puffer[n] := SendeByte;
    end;
  end;
end;

procedure Wiedergabe;
var n: Word;
begin
  with Probe do begin;
    Inline ($FA);
    for n:= 1 to 60000 do senden (Puffer[n]);
    Inline ($FB);
  end;
end;

procedure Speichern (Dateiname : String);
var f: file of Speicher;
begin
  assign (f,Dateiname);
  {$I-} rewrite (f); {$I+}
  write (f,Probe);
  close (f);
end;

procedure Laden (Dateiname : String);
var f: file of Speicher;
begin
  assign (f,Dateiname);
  {$I-} reset (f); {$I+}
  read (f,Probe);
  close (f);
end;

procedure Aufnehmen;
begin
  Aufnahme;
  Wiedergabe;
  writeln ('<A>ufnahme, <W>iedergabe, speichern unter <1> ...<6>, <E>nde');
  repeat
    repeat until KeyPressed;
    Ch := upcase (ReadKey);
    case Ch of
      'A' : begin Aufnahme; Wiedergabe; end;
      'W' : Wiedergabe;
      '1' : Speichern ('1.NF');
      '2' : Speichern ('2.NF');
      '3' : Speichern ('3.NF');
      '4' : Speichern ('4.NF');
      '5' : Speichern ('5.NF');
      '6' : Speichern ('6.NF');
      end;
  until Ch in ['E',chr(27)];
  end;

procedure Wiedergeben;
begin
  writeln ('laden und wiedergeben <1> ...<6>, <W>iedergeben, <E>nde');
  repeat
    repeat until KeyPressed;
    Ch := upcase (ReadKey);
    case Ch of
      'W' : Wiedergabe;
      '1' : begin Laden ('1.NF'); Wiedergabe; end;
      '2' : begin Laden ('2.NF'); Wiedergabe; end;
      '3' : begin Laden ('3.NF'); Wiedergabe; end;
      '4' : begin Laden ('4.NF'); Wiedergabe; end;
      '5' : begin Laden ('5.NF'); Wiedergabe; end;
      '6' : begin Laden ('6.NF'); Wiedergabe; end;
    end;
  until Ch in ['E',chr(27)];
end;

begin
  Oeffnen115200;
  repeat
    writeln ('<A>ufnehmen, <W>iedergeben, <Esc>');
    repeat until KeyPressed;
    Ch := upcase (ReadKey);
    case Ch of
      'A' : Aufnehmen;
      'W' : Wiedergeben;
    end;
  until Ch = chr(27);
end.
