Program U_f_Wandler;
Uses Crt;
Const  BA = $3F8;            { COM 1}
var Spannung, Kalibrierung : Real;
    Ch : Char;

procedure Zeitgeber;
begin
  Port[$43] := $24;          { Timer 0, Mode 2, Lesen: Highbyte}
  Port[$40] := lo (59659);   { Teilerfaktor }
  Port[$40] := hi (59659);   { = 1193180 / 20 }
end;

procedure Uhr;
begin
  Port[$43] := $36;          { Timer 0, Mode 3}
  Port[$40] := 0;            { Teilerfaktor }
  Port[$40] := 0;            { = 65536 }
end;


function Frequenz (Torzeit: Integer): Real;
var Dummy, Timer, Timer_alt : Integer;
    Eingang, Eingang_alt, Zeit : Byte;
    Portwert : Byte;
    Zaehler : Word;
begin
 Portwert := 16;                      { Eingang CTS }
 Zaehler := 0;
 Zeit := 0;

 Inline ($FA);                        { Interrupt sperren }
 Timer := Port[$40] and 128;          { hchstwertiges Bit }
 repeat;
   Timer_alt := Timer;
   Timer := Port[$40] and 128;
 until Timer > Timer_alt;             { 1. Timer-berlauf }
 Eingang_alt := Port[BA+6] AND Portwert;
 repeat
     Timer_alt := Timer;
     Eingang := Port[BA+6] AND Portwert;   { Flanken zhlen }
     if Eingang > Eingang_alt then Zaehler := Zaehler + 1;
     Eingang_alt := Eingang;
     Timer := Port[$40] and 128;      { berlufe zhlen }
     If Timer > Timer_alt then Zeit := Zeit +1;
 until Zeit = Torzeit;
 Inline ($FB);                        { Interrupt freigeben }
 Frequenz := Zaehler/Torzeit*20;
end;

begin
  Kalibrierung := 1.000;  { individuell anpassen }
  Zeitgeber;
  ClrScr;
  repeat
    GotoXY (1,1);
    writeln ('Spannung,  Auflsung: <1> 1mv   <2> 0,1mV   <3> 0,01mV   <Esc>');
    repeat until KeyPressed;
    Ch := ReadKey;
    Case Ch of
      '1':   repeat
               Spannung := Frequenz(2)/10*Kalibrierung;
               GotoXY (10,10);
               write ('U = ',Spannung:3:0, ' mV'); ClrEol;
             until KeyPressed;
      '2':   repeat
               Spannung := Frequenz(20)/10*Kalibrierung;
               GotoXY (10,10);
               write ('U = ',Spannung:3:1, ' mV'); ClrEol;
             until KeyPressed;
      '3':   repeat
               Spannung := Frequenz(200)/10*Kalibrierung;
               GotoXY (10,10);
               write ('U = ',Spannung:3:2, ' mV'); ClrEol;
             until KeyPressed;
    end;
  until Ch = chr (27);
  Uhr;
end.
